<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 64
0dbfs = 1
nchnls = 2

seed 0
gkflag init 0

opcode AllPass, a, a
	ain xin
	; Generate stable poles
	irad exprand 0.1
	irad = 0.99 - irad
	irad limit irad, 0, 0.99
	;iang random -$M_PI, $M_PI
	iang random -$M_PI, $M_PI
	ireal = irad * cos(iang)
	iimag = irad * sin(iang)
	print irad, iang, ireal, iimag
	
	; Generate coefficients from poles
	ia2 = (ireal * ireal) + (iimag * iimag)
	ia1 = -2*ireal
	ia0 = 1

	ib0 = ia2
	ib1 = ia1
	ib2 = ia0

	printf_i "ia0 = %.8f ia1 = %.8f ia2= %.8f\n", 1, ia0, ia1, ia2
	aout biquad ain, ib0, ib1, ib2, ia0, ia1, ia2
	

	xout aout
endop

opcode Orban, aa, akk
	ain, kwidth, kmode xin
	;; Cascade two filters to create a 4-pole all-pass
	a1 AllPass ain
	a1 AllPass a1

	a2 AllPass ain
	if kmode == 1 then
		a2 AllPass a2
	endif
	
	aout1 = a1*kwidth + a2
	aout2 = - a1*kwidth + a2
	
	xout aout1, aout2
endop

instr 1  ; Inputs and control
	gainput inch 1
	gkon_orban invalue "on_orban"
	gkwidth_orban invalue "width_orban"
	gklevel_orban invalue "level_orban"
	gkmode_orban invalue "mode_orban"
endin

instr 2 ; flag filter coefficients reinit
	gkflag = 1
	turnoff
endin

instr 13 ; Orban method
start:
if gkon_orban == 1 then
	aout1, aout2 Orban gainput*gklevel_orban, gkwidth_orban, gkmode_orban
else
	aout1 = gainput*gklevel_orban
	aout2 = gainput*gklevel_orban
endif


rireturn
if gkflag == 1 then
	gkflag = 0	
	reinit start
endif

outch 1, aout1, 2, aout2
endin

</CsInstruments>
<CsScore>
i 1 0 3600
i 13 0 3600
</CsScore>
</CsoundSynthesizer><bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>837</x>
 <y>311</y>
 <width>420</width>
 <height>403</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>170</r>
  <g>170</g>
  <b>127</b>
 </bgcolor>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>7</x>
  <y>6</y>
  <width>399</width>
  <height>347</height>
  <uuid>{4c919985-3409-41f4-8fbb-43e8dfb20801}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Orban method</label>
  <alignment>center</alignment>
  <font>DejaVu Sans</font>
  <fontsize>18</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="background">
   <r>129</r>
   <g>149</g>
   <b>91</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>5</borderradius>
  <borderwidth>3</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>39</x>
  <y>109</y>
  <width>80</width>
  <height>25</height>
  <uuid>{d4fdb81c-b8c8-4f79-bb49-d0cec19e5607}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Enable</label>
  <alignment>left</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBCheckBox">
  <objectName>on_orban</objectName>
  <x>21</x>
  <y>111</y>
  <width>20</width>
  <height>20</height>
  <uuid>{66b6c878-2a39-499a-b162-8761109dfc60}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <selected>false</selected>
  <label/>
  <pressedValue>1</pressedValue>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>114</x>
  <y>45</y>
  <width>80</width>
  <height>25</height>
  <uuid>{248a562b-78f5-4645-ba0b-17cbbd43c077}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Width gain</label>
  <alignment>left</alignment>
  <font>DejaVu Sans</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBHSlider">
  <objectName>width_orban</objectName>
  <x>19</x>
  <y>64</y>
  <width>278</width>
  <height>23</height>
  <uuid>{14814ddc-76ed-4069-a177-c2c1ee4a0e12}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.43165468</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">true</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBKnob">
  <objectName>level_orban</objectName>
  <x>301</x>
  <y>23</y>
  <width>74</width>
  <height>72</height>
  <uuid>{9a962245-1ac4-41bc-ac0e-2b08a18b5224}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>1.00000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>0.01000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>298</x>
  <y>93</y>
  <width>80</width>
  <height>25</height>
  <uuid>{c207900d-6fa8-426d-bd4f-1217f25145e4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Level</label>
  <alignment>center</alignment>
  <font>DejaVu Sans</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBScope">
  <objectName/>
  <x>15</x>
  <y>153</y>
  <width>192</width>
  <height>181</height>
  <uuid>{797f859d-d72b-4dbd-9608-86005905acf4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <value>-255.00000000</value>
  <type>lissajou</type>
  <zoomx>2.00000000</zoomx>
  <zoomy>2.00000000</zoomy>
  <dispx>1.00000000</dispx>
  <dispy>1.00000000</dispy>
  <mode>0.00000000</mode>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>width_orban</objectName>
  <x>116</x>
  <y>82</y>
  <width>80</width>
  <height>25</height>
  <uuid>{a5dc3cf6-236c-41a6-81c2-61ae2e79a05c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.432</label>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName>button1</objectName>
  <x>215</x>
  <y>154</y>
  <width>183</width>
  <height>30</height>
  <uuid>{0be35d2e-6bbd-4c48-b99e-5c61520dfe62}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>New Filter coefficients</text>
  <image>/</image>
  <eventLine>i 2 0 1</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>mode_orban</objectName>
  <x>267</x>
  <y>232</y>
  <width>80</width>
  <height>30</height>
  <uuid>{c41c4950-c05f-4174-9a55-9731f0a5796f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>2-pole</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>4-pole</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>0</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>237</x>
  <y>208</y>
  <width>140</width>
  <height>24</height>
  <uuid>{414e0875-d51e-4164-8d4e-8142c2cd09d4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Second filter mode</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {43690, 43690, 32639}
ioText {7, 6} {399, 347} label 0.000000 0.00100 "" center "DejaVu Sans" 18 {65280, 65280, 65280} {33024, 38144, 23296} nobackground noborder Orban method
ioText {39, 109} {80, 25} label 0.000000 0.00100 "" left "Lucida Grande" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Enable
ioCheckbox {21, 111} {20, 20} off on_orban
ioText {114, 45} {80, 25} label 0.000000 0.00100 "" left "DejaVu Sans" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Width gain
ioSlider {19, 64} {278, 23} 0.000000 1.000000 0.431655 width_orban
ioKnob {301, 23} {74, 72} 1.000000 0.000000 0.010000 1.000000 level_orban
ioText {298, 93} {80, 25} label 0.000000 0.00100 "" center "DejaVu Sans" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Level
ioGraph {15, 153} {192, 181} lissajou 2.000000 -255 
ioText {116, 82} {80, 25} display 0.431655 0.00100 "width_orban" left "Arial" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder 0.432
ioButton {215, 154} {183, 30} event 1.000000 "button1" "New Filter coefficients" "/" i 2 0 1
ioMenu {267, 232} {80, 30} 0 303 "2-pole,4-pole" mode_orban
ioText {237, 208} {140, 24} label 0.000000 0.00100 "" center "Arial" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Second filter mode
</MacGUI>
